diff --git a/drivers/gpu/drm/i915/i915_debugfs.c b/drivers/gpu/drm/i915/i915_debugfs.c
index 9c2b9e4..79c876e 100644
--- a/drivers/gpu/drm/i915/i915_debugfs.c
+++ b/drivers/gpu/drm/i915/i915_debugfs.c
@@ -4968,6 +4968,119 @@ static const struct file_operations i915_dpcd_fops = {
 	.release = single_release,
 };
 
+static ssize_t i915_dpcd_addr_write(struct file *file, const char __user *ubuf,
+				     size_t len, loff_t *offp)
+{
+	struct seq_file *m = file->private_data;
+	struct drm_connector *connector = m->private;
+	struct intel_dp *intel_dp =
+		enc_to_intel_dp(&intel_attached_encoder(connector)->base);
+	unsigned int reg_addr;
+	char tmp[16];
+
+	if (len >= sizeof(tmp))
+		return -EINVAL;
+
+	if (copy_from_user(tmp, ubuf, len))
+		return -EFAULT;
+
+	tmp[len] = '\0';
+
+	if (kstrtouint(tmp, 16, &reg_addr))
+		return -EINVAL;
+
+	intel_dp->debugfs_dpcd_addr = reg_addr;
+
+	return len;
+}
+
+static int i915_dpcd_addr_show(struct seq_file *m, void *data)
+{
+	struct drm_connector *connector = m->private;
+	struct intel_dp *intel_dp =
+		enc_to_intel_dp(&intel_attached_encoder(connector)->base);
+
+	seq_printf(m, "0x%x\n", intel_dp->debugfs_dpcd_addr);
+
+	return 0;
+}
+
+static int i915_dpcd_addr_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, i915_dpcd_addr_show, inode->i_private);
+}
+
+static const struct file_operations i915_dpcd_addr_fops = {
+	.owner = THIS_MODULE,
+	.open = i915_dpcd_addr_open,
+	.read = seq_read,
+	.write = i915_dpcd_addr_write,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
+static ssize_t i915_dpcd_val_write(struct file *file, const char __user *ubuf,
+				     size_t len, loff_t *offp)
+{
+	struct seq_file *m = file->private_data;
+	struct drm_connector *connector = m->private;
+	struct intel_dp *intel_dp =
+		enc_to_intel_dp(&intel_attached_encoder(connector)->base);
+	unsigned int addr = intel_dp->debugfs_dpcd_addr;
+	unsigned int val;
+	char tmp[16];
+	int ret;
+
+	if (len >= sizeof(tmp))
+		return -EINVAL;
+
+	if (copy_from_user(tmp, ubuf, len))
+		return -EFAULT;
+
+	tmp[len] = '\0';
+
+	if (kstrtouint(tmp, 16, &val))
+		return -EINVAL;
+
+	ret = drm_dp_dpcd_writeb(&intel_dp->aux, addr, val);
+	if (ret < 0)
+		return ret;
+
+	return len;
+}
+
+static int i915_dpcd_val_show(struct seq_file *m, void *data)
+{
+	struct drm_connector *connector = m->private;
+	struct intel_dp *intel_dp =
+		enc_to_intel_dp(&intel_attached_encoder(connector)->base);
+	unsigned int addr;
+	u8 val;
+	int ret;
+
+	addr = intel_dp->debugfs_dpcd_addr;
+	ret = drm_dp_dpcd_readb(&intel_dp->aux, addr, &val);
+	if (ret < 0)
+		return ret;
+
+	seq_printf(m, "0x%x\n", val);
+	return 0;
+}
+
+static int i915_dpcd_val_open(struct inode *inode, struct file *file)
+{
+	return single_open(file, i915_dpcd_val_show, inode->i_private);
+}
+
+static const struct file_operations i915_dpcd_val_fops = {
+	.owner = THIS_MODULE,
+	.open = i915_dpcd_val_open,
+	.read = seq_read,
+	.write = i915_dpcd_val_write,
+	.llseek = seq_lseek,
+	.release = single_release,
+};
+
 /**
  * i915_debugfs_connector_add - add i915 specific connector debugfs files
  * @connector: pointer to a registered drm_connector
@@ -4986,9 +5099,14 @@ int i915_debugfs_connector_add(struct drm_connector *connector)
 		return -ENODEV;
 
 	if (connector->connector_type == DRM_MODE_CONNECTOR_DisplayPort ||
-	    connector->connector_type == DRM_MODE_CONNECTOR_eDP)
+	    connector->connector_type == DRM_MODE_CONNECTOR_eDP) {
 		debugfs_create_file("i915_dpcd", S_IRUGO, root, connector,
 				    &i915_dpcd_fops);
+		debugfs_create_file("i915_dpcd_addr", S_IRUGO | S_IWUSR,
+				root, connector, &i915_dpcd_addr_fops);
+		debugfs_create_file("i915_dpcd_val", S_IRUGO | S_IWUSR,
+				root, connector, &i915_dpcd_val_fops);
+	}
 
 	return 0;
 }
diff --git a/drivers/gpu/drm/i915/intel_drv.h b/drivers/gpu/drm/i915/intel_drv.h
index 23a42a4..4477d14 100644
--- a/drivers/gpu/drm/i915/intel_drv.h
+++ b/drivers/gpu/drm/i915/intel_drv.h
@@ -709,6 +709,7 @@ struct intel_dp {
 	unsigned long last_power_cycle;
 	unsigned long last_power_on;
 	unsigned long last_backlight_off;
+	unsigned int debugfs_dpcd_addr;
 
 	struct notifier_block edp_notifier;
 